Description

I find the table sorting introduced by #1718 annoying because most of the tables I use are not usefully sortable and the sort as

implemented can be a nuisance.

I would like an option to turn off the JavaScript sorting globally, that is, restore the behavior prior to #1718.

Globally might mean "per project." I use Redmine hosted on Planio and I'm not sure how the clients there are technically separated.

The specific problems are immaterial if there's an option to turn off table sorting, but I'll show the problems as motivation.

For example, I use tables like this:

First group Gizmos A

Second Widgets B

Third Widgets A

Gizmos B

Fourth Gadgets

Hovering table headers causes the sort arrow to appear briefly. That changes the dimensions of the cells and can cause a jarring

blinking effect as the table columns resize.

It's hard to select part of the text in a table cell. If I click and drag over just the word "first" for example, when I let up the mouse

button, it sorts instead of keeping my selection. I can work around this by moving the mouse outside the cell before letting up the

button, but that's easily forgotten.

Once I've sorted the table one time, often by accident as above, no amount of clicking returns it to the original order. An example

table on RedmineTextFormattingTextile suffers from this problem as well.

The example table from RedmineTextFormattingTextile also shows that apparently the same sorting choice can produce different

orderings.
That might be related to improper handling of row and column spans. With the simpler example here, a rowspan can rearrange cells

into the wrong columns and associate them with the wrong headers.
#1718#note-17 lists some other potential problems.

Wiki syntax to disable sort per table or per column would be an alternative. Such syntax might already exist since #1718 says I can

"explicitly set the sort algorithm by adding one of the following classNames to the associated table header… sortable-keep (which

keeps the row in it’s original order)." Forgive my ignorance, but I don't know how to add classNames in wiki syntax, 

RedmineTextFormattingTextile doesn't mention it.

For me, however, removing JavaScript sort or a global option to turn it off would be better that fine-grained wiki syntax.

Related issues:

Related to Redmine - Feature #1718: Table column sorting Closed 2008-07-30

Associated revisions

Revision 23401 - 2024-12-11 20:08 - Marius BĂLTEANU

Adds global setting In Display tab to disable JS based table sort in wiki content (#40588).

Patch by Jens Krämer (user:jkraemer).

Revision 23499 - 2025-02-09 06:57 - Go MAEDA

Update locales (#40588).

Revision 23813 - 2025-06-01 22:41 - Marius BĂLTEANU

Set default for "Javascript based table sorting in wiki content" to disabled for new installations (#40588).

Revision 23828 - 2025-06-11 21:45 - Marius BĂLTEANU

Add missing migration for #40588 that keeps the wiki_tablesort_enabled setting unchanged for existing installations.

History

#1 - 2024-04-25 07:32 - Marius BĂLTEANU

- Related to Feature #1718: Table column sorting added

#2 - 2024-04-25 07:34 - Marius BĂLTEANU

- Status changed from New to Needs feedback

I agree with you regarding this table sorting feature, most of the time is not working properly for my cases.

Go MAEDA, what do you thing if we add a feature flag for this?

#3 - 2024-06-03 10:57 - Go MAEDA

Marius BĂLTEANU wrote in #note-2:

I agree with you regarding this table sorting feature, most of the time is not working properly for my cases.

Go MAEDA, what do you thing if we add a feature flag for this?

 I don’t oppose to add a new system setting.

#4 - 2024-12-09 08:52 - Jens Krämer

- File 0001-adds-setting-to-disable-JS-based-table-sort-in-wiki-.patch added

the attached patch adds a setting to disable the table sorting

#5 - 2024-12-11 20:11 - Marius BĂLTEANU

- Category set to UI

- Status changed from Needs feedback to Resolved

- Assignee set to Marius BĂLTEANU
- Target version set to 6.1.0

- Resolution set to Fixed

Patch committed, thanks Jens Krämer!

Reading also the notes from Mischa (#1718#note-17), what do you think about having this setting disabled for new installations?

#6 - 2025-06-01 22:43 - Marius BĂLTEANU

- Subject changed from Ability to disable table sort to Add new setting "Javascript based table sorting in wiki content " to disable table sort

- Status changed from Resolved to Closed

Default setting changed in r23813 to disabled for new installations.
